N=10^3;
d=randi([2,5]);
fprintf('Generating A a %d-by-%d-by-%d 3D-array with \n',N,d,d);
fprintf('    A(k,:,:)=L(k,:,:)*U(k,:,:), for all k\n')
fprintf('where L(k,:,:) and U(k,:,:) are respectively a lower and an upper triangular matrices\n')
L=fc_linalg3D.random.randtril(N,d); 
U=fc_linalg3D.random.randtriu(N,d);
A=fc_linalg3D.mtimes(L,U);

Dex=fc_linalg3D.diagprodVec(L).*fc_linalg3D.diagprodVec(U);

funs={'det_Ref','detLaplace_Cpt','detLaplace_Mat','detLaplace_Vec','detLapIdx_Vec', ...
      'det_pLUinplace_Vec','det_pLUinplace_Vec'};
      
for i=1:length(funs)
  cfun=funs{i};
  fun=eval(['@(varargin) fc_linalg3D.det.',funs{i},'(varargin{:})']);
  D=fun(A);
  fprintf('Error=%.4f with %s function\n',max(abs(D-Dex)),func2str(fun))
end
