function D=detMix_Vec(A)
% Only for symmetric/hermitian positive definite matrices
% A : N-by-d-by-d
% D : N-by-1
% D(i) = det A(i,:,:)
% https://www.researchgate.net/profile/Omid_Rezaifar/publication/220561323_A_new_approach_for_finding_the_determinant_of_matrices/links/59c0974baca272aff2e21691/A-new-approach-for-finding-the-determinant-of-matrices.pdf
% Formula modify by F.C. to work with symmetric/hermitian positive definite matrices
  N=size(A,1);d=size(A,2);
  if d==1, D=A(:,1,1); return; end
  assert( fc_linalg3D.is3Darray(A) && size(A,2)==size(A,3) )
  D=zeros(N,1);
  if d==2, D=(A(:,1,1).*A(:,2,2)-A(:,1,2).*A(:,2,1)); return;end
  I1=2:d;Id=1:d-1;I1d=2:d-1;
  D=fc_linalg3D.det.detMix_Vec(A(:,I1,I1)).*fc_linalg3D.det.detMix_Vec(A(:,Id,Id));
  D=D-fc_linalg3D.det.detLaplace_Vec(A(:,I1,Id)).^2;
  D=D./fc_linalg3D.det.detMix_Vec(A(:,I1d,I1d));
end
