function B=cholesky(A)
% Positive Cholesky factorization A = B B^* where
% A is a n-by-n symmetric positive definite matrix and
% B is a n-by-n lower triangular matrix 
  n=size(A,1);
  B=zeros(n,n);
  
  for j=1:n
    B(j,j)=sqrt(A(j,j)-sum(abs(B(j,1:j-1)).^2));
    for i=j+1:n
      B(i,j)=(A(i,j)-sum(B(i,1:j-1).*conj(B(j,1:j-1))))/B(j,j);
    end
  end
end
