function C=aXpbY_Cpt(a,X,b,Y)
% function C=aXpbY_Cpt(a,X,b,Y)
%   returns C=a*X+b*Y
%    C=aXpbY_init(a,X,b,Y); % 
%    if ~isempty(C), return;end
%    assert( isscalar(a) && isscalar(b) )
%    if max(size(X))==1 || max(size(Y))==1, C=a*X+b*Y;return;end % X or Y is constant (to improve performance)
%    if fc_linalg3D.is3Darray(X) && fc_linalg3D.is3Darray(Y), C=a*X+b*Y;return;end % X and Y are 3D-arrays (to improve performance)
  C=fc_linalg3D.aXpbY_init(a,X,b,Y); % 
  if ~isempty(C), return;end
  [getX,getY,N,dimX,dimY]=fc_linalg3D.getCpts(X,Y);
  m=max(dimX(2),dimY(2));n=max(dimX(3),dimY(3));
  C=zeros(N,m,n);
  for k=1:N
    for i=1:m
      for j=1:n
        C(k,i,j)=a*getX(X,k,i,j)+b*getY(Y,k,i,j);
      end
    end
  end
end
